

void draw() {

  rotateY(PI/2);
  translate(-3000, 0, 0);

  background(0);
  frameRate(15);


  sameitem();

  dots();

  //emissive(128);

  grid();
  textpart();
}

void grid() {



  stroke(100);

  //for (int h=0;h<10;h++) {
  for (int i=1;i<10;i++) {
    line(-3600, 460, 1000-200*i, 3600, 460, 1000-200*i);
  }
  for (int i=1;i<6;i++) {
    line(-3600+1200*i, 460, 1000, -3600+1200*i, 460, -1000);
  }
  //}


  //line(-720, -460, 1000, 720, -460, 1000-);
}
void dots() {

  noStroke();
  lights();
  emissive(100);



  for (int i=0;i<72;i++) {  

    for (int j=0; j<30;j++) {

      if ((30*i+j)%30<20) {



      pushMatrix();
      translate(-3600+100*i, nummap[30*i+j], deweymap[30*i+j]);



      //deweycolor
      if (colordewey) {
        if (deweycolor[30*i+j]==0)
          fill(a1);
        else if (deweycolor[30*i+j]==1)
          fill(a2);
        else if (deweycolor[30*i+j]==2)
          fill(a3);
        else if (deweycolor[30*i+j]==3)
          fill(a4);
        else if (deweycolor[30*i+j]==4)
          fill(a5);
        else if (deweycolor[30*i+j]==5)
          fill(a6);
        else if (deweycolor[30*i+j]==6)
          fill(a7);
        else if (deweycolor[30*i+j]==7)
          fill(a8);
        else if (deweycolor[30*i+j]==8)
          fill(a9);
        else if (deweycolor[30*i+j]==9)
          fill(a10);

        sphereDetail(4);
        sphere(10);
      }

      //kindcolor
      else if (colorkind) {

        if (kind[30*i+j].equals("acbk")) {
          //emissive(255);  
          fill(a2);
        }
        else if (kind[30*i+j].equals("accd")) {
          //emissive(0); 
          fill(a4);
        }
        else if (kind[30*i+j].equals("acdvd")) {
          //emissive(0); 
          fill(a6);
        }
        else if (kind[30*i+j].equals("jcbk")) {
          //emisive(0); 
          fill(a8);
        }
        else {
          //emissive(0); 
          fill(a10);
        }

        sphereDetail(4);
        sphere(10);
      }


      //rankcolor
      else if (colorrank) {
        if (rankcolor[30*i+j]<1) {
          fill(a1);
        }
        else if (rankcolor[30*i+j]<5&&rankcolor[30*i+j]>0) {
          fill(a2);
          //sphereDetail(5);
          //sphere(15);
        }
        else if (rankcolor[30*i+j]<10&&rankcolor[30*i+j]>4) {
          fill(a3);
        }
        else if (rankcolor[30*i+j]<20&&rankcolor[30*i+j]>9)
          fill(a4);
        else if (rankcolor[30*i+j]<30&&rankcolor[30*i+j]>19)
          fill(a5);

        sphereDetail(4);
        sphere(10);
      }





      popMatrix();
    }
    }
  }
}
void sameitem() {

  if (colortext) {
    emissive(255);
    textAlign(CENTER, CENTER);
    textSize(10);
    pushMatrix();
    rotateY(-PI/2);

    for (int j=0;j<72;j++) {
      for (int i=0;i<30;i++) {

        if ((30*j+i)%30<5) {

          text(title[30*j+i], deweymap[30*j+i], samemap[30*j+i], 3600-100*j);
        }
      }
    }
    popMatrix();
  }
}

