//
// Mat259 Final Project
// 3D Visulization
// by Yeu-Shuan Tang
//
//

import processing.opengl.*;
//import peasy.test.*;
//import peasy.org.apache.commons.math.*;
import peasy.*;
//import peasy.org.apache.commons.math.geometry.*;

PeasyCam cam;

void setup() {
  size(880, 700, OPENGL);
  colorMode(HSB, 360, 100, 100);
  smooth();

  //set camera
  cam= new PeasyCam(this, -150, 200, 0, 9000);
  cam.setMinimumDistance(50);
  cam.setMaximumDistance(9000);

  //load data
  months1=loadStrings("month.txt");
  dewey1=loadStrings("dewey.txt");
  num1=loadStrings("count.txt");
  title=loadStrings("title.txt");
  kind=loadStrings("kind.txt");
  
  for(int i=0;i<2160;i++){

    for(int j=0;j<2160;j++){
      
      if(title[i].equals(title[j]))
      same[i]++;
     
    }
    //println(same[i]);
  }
  
  

  for (int i=0;i<2160;i++) {
    months[i]=Integer.parseInt(months1[i]);
    dewey[i]=Integer.parseInt(dewey1[i]);
    num[i]=Integer.parseInt(num1[i]);

    //println(title[i]);

    nummap[i]=(int)map(num[i], min(num), max(num), 540, -560);
    deweymap[i]=(int)map(dewey[i], 0, 1000, 1000, -1000);
    samemap[i]=(int)map(same[i],min(same),max(same),540,-260);
    deweycolor[i]=floor(dewey[i]/100);
    rankcolor[i]=i%30;

    //if (kind[i].equals("acbk"))
    //println("yes");

    //println(kind[i]);
  }


  a1=color(0, 100, 65, 230);
  a2=color(36, 81, 78, 230);
  a3=color(65, 90, 98, 230);
  a4=color(108, 81, 80, 230);
  a5=color(144, 97, 45, 230);
  a6=color(180, 83, 70, 230);
  a7=color(216, 95, 85, 230);
  a8=color(252, 80, 90, 230);
  a9=color(288, 100, 100, 230);
  a10=color(324, 63, 80, 230);
  
  
  
  
  
}

